---
title: AudioScheduledSourceNode.onended
slug: Web/API/AudioScheduledSourceNode/onended
tags:
  - API
  - Audio
  - AudioBufferSourceNode
  - AudioScheduledSourceNode
  - ConstantSourceNode
  - Event Handler
  - Media
  - OscillatorNode
  - Property
  - Web Audio API
  - onended
---
<p>{{APIRef("Web Audio API")}}</p>

<p>The <code>onended</code> event handler for the <code>AudioScheduledSourceNode</code> interface specifies an {{domxref("EventHandler")}} to be executed when the {{event("ended")}} event occurs on the node. This event is sent to the node when the concrete interface (such as {{domxref("AudioBufferSourceNode")}}, {{domxref("OscillatorNode")}}, or {{domxref("ConstantSourceNode")}}) determines that it has stopped playing.</p>

<div class="note">
<p>The {{event("ended")}} event is only sent to a node configured to loop automatically when the node is stopped using its {{domxref("AudioScheduledSourceNode.stop", "stop()")}} method. This is the case, for example, when using an {{domxref("AudioBufferSourceNode")}} with its {{domxref("AudioBufferSourceNode.loop", "loop")}} property set to <code>true</code>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>AudioScheduledSourceNode</em>.onended = <em>EventHandler</em>;
</pre>

<h3 id="Value">Value</h3>

<p>A function which is called by the browser when the {{event("ended")}} event occurs on the {{domxref("AudioScheduledSourceNode")}}. The function receives as input a single parameter, which is an object of type {{domxref("Event")}} describing the event that occurred.</p>

<h2 id="Examples">Examples</h2>

<p>In this simple example, an event listener for the {{event("ended")}} event is set up to enable a "Start" button in the user interface when the node stops playing.</p>

<pre class="brush: js">node.onended = function(event) {
  document.getElementById("startButton").disabled = false;
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('Web Audio API', '#dom-audioscheduledsourcenode-onended', 'onended') }}</td>
   <td>{{ Spec2('Web Audio API') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.AudioScheduledSourceNode.onended")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The <code><a href="/en-US/docs/Web/API/AudioScheduledSourceNode/onended">ended</a></code> event and its type, {{domxref("Event")}}.</li>
 <li>{{domxref("AudioScheduledSourceNode")}}</li>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a></li>
</ul>
